/*************************************************************************************************
Dmitri Korotkevitch
http://aboutsqlserver.com
email: dmitri@aboutsqlserver.com

24HOP Russia (2015) - Size does Matter
03.Instant File Initialization Demo
*************************************************************************************************/
set nocount on
set xact_abort on
go

use master
go

if exists (select * from sys.databases where name ='IFIDemo')
begin
	alter database IFIDemo set single_user with rollback immediate
	drop database IFIDemo
end
go

-- Clearing Wait Statistics
dbcc sqlperf('sys.dm_os_wait_stats', clear) 
go

-- Trace Flag put extra info to the log
dbcc traceon(3004,3605,-1)
go

create database IFIDemo
on primary
(name = N'IFIDemo_Primary', filename = N's:\db\IFIDemo.mdf' , size = 1500MB , filegrowth = 1000KB)
log on
(name = N'IFIDemo_log', filename = N's:\db\IFIDemo_log.ldf' , size = 10MB , filegrowth = 1000KB)
go

dbcc traceoff(3004,3605,-1)
go

exec sp_readerrorlog
go

/*
select 
	wait_type
	,wait_time_ms 
	,convert(decimal(7,4), 100.0 * wait_time_ms / sum(wait_time_ms) over()) as [Percent]
from sys.dm_os_wait_stats with (nolock)
where 
	wait_type not in -- Filtering out non-essential system waits 
	(N'CLR_SEMAPHORE',N'LAZYWRITER_SLEEP',N'RESOURCE_QUEUE'
	,N'SLEEP_TASK',N'SLEEP_SYSTEMTASK',N'SQLTRACE_BUFFER_FLUSH'
	,N'WAITFOR',N'LOGMGR_QUEUE',N'CHECKPOINT_QUEUE'
	,N'REQUEST_FOR_DEADLOCK_SEARCH',N'XE_TIMER_EVENT'
	,N'BROKER_TO_FLUSH',N'BROKER_TASK_STOP',N'CLR_MANUAL_EVENT'
	,N'CLR_AUTO_EVENT',N'DISPATCHER_QUEUE_SEMAPHORE'
	,N'FT_IFTS_SCHEDULER_IDLE_WAIT',N'XE_DISPATCHER_WAIT'
	,N'XE_DISPATCHER_JOIN',N'SQLTRACE_INCREMENTAL_FLUSH_SLEEP'
	,N'ONDEMAND_TASK_QUEUE',N'BROKER_EVENTHANDLER',N'SLEEP_BPOOL_FLUSH'
	,N'SLEEP_DBSTARTUP',N'DIRTY_PAGE_POLL',N'BROKER_RECEIVE_WAITFOR'
	,N'HADR_FILESTREAM_IOMGR_IOCOMPLETION', N'WAIT_XTP_CKPT_CLOSE'
	,N'SP_SERVER_DIAGNOSTICS_SLEEP',N'BROKER_TRANSMITTER'
	,N'QDS_PERSIST_TASK_MAIN_LOOP_SLEEP','MSQL_XP'
	,N'QDS_CLEANUP_STALE_QUERIES_TASK_MAIN_LOOP_SLEEP'
	,N'WAIT_XTP_HOST_WAIT', N'WAIT_XTP_OFFLINE_CKPT_NEW_LOG')
order by 
	[Percent] Desc
option (recompile);
go
*/
